#	define	InstructionTypes	3

#	define	InstructionTypeInteger			0
#	define	InstructionTypeFloatingPoint	1
#	define	InstructionTypeMemory			2

#	define	InstructionTypeAll				3
	
typedef	struct	_rawInstruction
	{
	unsigned	int	Operation:3;
	unsigned	int	Output1:7;
	unsigned	int	Output2:7;
	unsigned	int	Input1:7;
	unsigned	int	Input2:7;
	unsigned	int	Input3:7;
	}	rawInstruction;

class	ProcessorStage;

enum	BranchOutcome
	{
	Taken	=	1,
	NotTaken,
	DontKnow
	};

class	Instruction
	{
	public:
	// simulation information
		uint64			Sequence;
		uint64			RawSequence;
		uint64			LoadStoreSequence;
		uint64			RawLoadStoreSequence;
		uint64			StoreSequence;
		uint64			RawStoreSequence;
		uint64			ProgramCounter;
		uint64			NextProgramCounter;
		uint64			MemoryAddress;
		uint			MemoryTransactionSize;
		BranchOutcome	RealBranchOutcome;
		BranchOutcome	PredictedBranchOutcome;
		ProcessorStage	*CurrentProcessorStage;
		int				theInstructionType;
		bool			MisSpeculatedInstruction;
		bool			RollBackOnThisInstruction;
	
		int	Operation;
		int	Output1;
		int	Output2;
		int	Input1;
		int	Input2;
		int	Input3;
		int	AddToFreeList1;
		int	AddToFreeList2;
		int	rOutput1, rOutput2,rInput1, rInput2, rInput3;	// raw "unrenamed" registers
		int	Executed;
		int	Dispatched;
		int	MemoryExecuted;
		int	MemoryDispatched;
		int	InFireQueue;
		int	Delay;

		int	BranchIndex1;

		AlphaInstruction	theAlphaInstruction;

		inline	uint64	Indexer()	{	return(Sequence); }
		int	InstructionType();
		bool	Finalize();

		bool	MakeNOP();
		bool	IsNOP();
		
	};

#	define	OpUnknown				0
#	define	OpInteger				1
#	define	OpFloatingPoint			2
#	define	OpLoad					3
#	define	OpStore					4
#	define	OpBranch				5
#	define	OpIndirectBranch		6
#	define	OpSystem				7

#	define	TotalOps				8

extern	char		*OpNames[TotalOps];

#	define	ZeroRegister		31
#	define	NoRegister			(32+32+1)
#	define	FlagRegister		(32+32)
#	define	ArchRegisterSize	(32+32+2)


bool	inline	operator	==	(Instruction	&theInstruction1, Instruction	&theInstruction2) { return(theInstruction1.Sequence == theInstruction2.Sequence); }
bool	inline	operator	<	(Instruction	&theInstruction1, Instruction	&theInstruction2) { return(theInstruction1.Sequence < theInstruction2.Sequence); }
bool	inline	operator	>	(Instruction	&theInstruction1, Instruction	&theInstruction2) { return(theInstruction1.Sequence > theInstruction2.Sequence); }


