#	include	"Simulator.h"


SingleIssueProcessor	::	SingleIssueProcessor ()
	{
	InstructionCount = 0;
	Stalled = 0;
	Halted = false;
	}

bool
SingleIssueProcessor	::	PrintStatistics (
	int		Format,
	FILE	*fp)
	{
	PrintValue(Format, fp, "InstructionCount", InstructionCount);
	return(true);
	}

bool
SingleIssueProcessor	::	Halt()
	{
	Halted = true;
	--NumberOfActiveProcessors;
	return(true);
	}

bool
SingleIssueProcessor	::	NotifyAboutStall(
	Component	*From,
	int			Cycles)
	{
	Stalled += Cycles;
	return ( true );
	}

int
SingleIssueProcessor	::	SimulateOneClockCycle()
	{
	int	Temp1, Temp2;


	if ( ! theAlphaProcessor )	return ( 100 );	// no processor yet.  call me later

	if(Halted)	return(-1);
	if( Stalled > 0)
		{
		--Stalled;
		return ( 1 );
		}

	while ( theSimulator->FastForward )
		{
		Instruction	*fInstruction = NEW(Instruction);
		if ( ! theAlphaProcessor->NextInstruction(&fInstruction) )
			{
			Halt();
			return(-1);
			}
		DELETE(Instruction, fInstruction);
		}
	Instruction	*theInstruction = NEW(Instruction);
	if ( ! theAlphaProcessor->NextInstruction(&theInstruction) )
		{
		DELETE(Instruction, theInstruction);
		Halt();
		return(-1);
		}	


	++InstructionCount;
	if(!theAlphaProcessor->Pause)
		++theSimulator->totalInstructionsExecuted;

	// talk to instruction cache
	theInstructionMemorySystem->ScheduleOperation(false, theInstruction->ProgramCounter, 8,
		0, &Temp1, &Temp2);
	Stalled += (Temp2-1);

	if ( theInstruction->Operation == OpLoad )
		{	
		// talk to data cache for a read
		this->theDataMemorySystem->ScheduleOperation
			(false, theInstruction->MemoryAddress, 1, 0, &Temp1, &Temp2);
		Stalled += Temp2;
		}

	if ( theInstruction->Operation == OpStore )
		{
		// talk to data cache for a write
		this->theDataMemorySystem->ScheduleOperation
			(true, theInstruction->MemoryAddress, 1, 0, &Temp1, &Temp2);
		Stalled += Temp2;
		}
	
	DELETE(Instruction, theInstruction);


	if ( theSimulator->StartThread )
		StartProcessor();
	return ( 1 );	// call back in 1 cycle
	}



