#	include	"Standard.h"

#	define	Dec16Format		"%d"
#	define	Dec32Format		"%d"
#	define	Dec64Format		"" format_dec_int64 ""
#	define	Hex16Format		"%4.4x"
#	define	Hex32Format		"%8.8x"
#	define	Hex64Format		"" format_hex_uint64 ""
#	define	StringFormat	"%s"

#	define	Dec16Format_cast	(uint16)
#	define	Dec32Format_cast	(uint32)
#	define	Dec64Format_cast	(uint64)
#	define	Hex16Format_cast	(uint16)
#	define	Hex32Format_cast	(uint32)
#	define	Hex64Format_cast	(uint64)
#	define	StringFormat_cast	(char *)

#define	DumpValue(format, name) \
	printf(""#name " = " format "\n", format##_cast name)


bool
Loader	::	DumpHeader (
	AlphaBinaryFileHeader	*FileHeader)
	{
	DumpValue(Hex16Format,	FileHeader->MagicNumber);
	DumpValue(Dec16Format,	FileHeader->NumberOfSections);
	DumpValue(Hex32Format,	FileHeader->TimeData);
	DumpValue(Hex64Format,	FileHeader->SymbolPointer);
	DumpValue(Hex16Format,	FileHeader->OptionalHeader);
	DumpValue(Hex16Format,	FileHeader->Flags);
	return(true);
	}

bool
Loader	::	DumpHeader (
	AlphaBinaryAOutHeader	*AOutHeader)
	{
	DumpValue(Hex16Format,	AOutHeader->MagicNumber);
	DumpValue(Hex16Format,	AOutHeader->Version);
	DumpValue(Hex16Format,	AOutHeader->BuildRevision);
	DumpValue(Hex16Format,	AOutHeader->Padding);
	DumpValue(Hex64Format,	AOutHeader->TextSize);
	DumpValue(Hex64Format,	AOutHeader->DataSize);
	DumpValue(Hex64Format,	AOutHeader->BssSize);
	DumpValue(Hex64Format,	AOutHeader->InitialPC);
	DumpValue(Hex64Format,	AOutHeader->TextStart);
	DumpValue(Hex64Format,	AOutHeader->DataStart);
	DumpValue(Hex64Format,	AOutHeader->BssSize);
	DumpValue(Hex32Format,	AOutHeader->GPRMask);
	DumpValue(Hex32Format,	AOutHeader->FPRMask);
	DumpValue(Hex64Format,	AOutHeader->GPValue);
	return ( true );
	}

bool
Loader	::	DumpHeader (
	AlphaBinarySectionHeader	*SectionHeader)
	{
	DumpValue(StringFormat,	SectionHeader->Name);
	DumpValue(Hex64Format,	SectionHeader->PhysicalAddress);
	DumpValue(Hex64Format,	SectionHeader->VirtualAddress);
	DumpValue(Hex64Format,	SectionHeader->Size);
	DumpValue(Hex64Format,	SectionHeader->SectionPointer);
	DumpValue(Hex64Format,	SectionHeader->RelativePointer);
	DumpValue(Hex64Format,	SectionHeader->Options);
	DumpValue(Hex16Format,	SectionHeader->NumberOfRelocatableSymbols);
	DumpValue(Hex16Format,	SectionHeader->NumberOfOptions);
	DumpValue(Hex32Format,	SectionHeader->Flags);
	return ( true );
	}

bool
Loader	::	DumpHeader (
	LinuxAlphaBinaryFileHeader	*FileHeader)
	{
	DumpValue(StringFormat,	FileHeader->MagicNumber);
	DumpValue(Hex64Format, FileHeader->Padding);
	DumpValue(Hex64Format, FileHeader->InitialPC);
	DumpValue(Hex64Format, FileHeader->ProgramHeaderOffset);
	DumpValue(Dec64Format, FileHeader->SectionHeaderOffset);
//	DumpValue(Dec32Format, FileHeader->Version);
//	DumpValue(Hex32Format, FileHeader->Flags);
	DumpValue(Hex16Format, FileHeader->FileType);
	DumpValue(Hex16Format, FileHeader->Machine);
	DumpValue(Dec16Format, FileHeader->HeaderSize);
	DumpValue(Dec16Format, FileHeader->ProgramHeaderTableSize);
	DumpValue(Dec16Format, FileHeader->ProgramHeaderTableCount);
	DumpValue(Dec16Format, FileHeader->NumberOfSections);
	DumpValue(Dec16Format, FileHeader->SectionHeaderStringIndex);
	return(true);
	}

bool
Loader	::	DumpHeader (
	LinuxAlphaBinarySectionHeader	*SectionHeader)
	{
	DumpValue(Dec32Format, SectionHeader->Name);
	DumpValue(Dec32Format, SectionHeader->Type);
	DumpValue(Hex64Format, SectionHeader->Flags);
	DumpValue(Hex64Format, SectionHeader->VirtualAddress);
	DumpValue(Dec32Format, SectionHeader->Size);
	DumpValue(Dec32Format, SectionHeader->EntrySize);
	DumpValue(Dec32Format, SectionHeader->Link);
	DumpValue(Dec32Format, SectionHeader->Info);
	DumpValue(Dec32Format, SectionHeader->SectionPointer);
	DumpValue(Dec32Format, SectionHeader->Alignment);
	return(true);
	}

bool
Loader	::	DumpHeader (
	LinuxAlphaBinaryProgramHeader	*ProgramHeader )
	{
	DumpValue(Dec32Format, ProgramHeader->Type);
	DumpValue(Hex32Format, ProgramHeader->Flags);
	DumpValue(Hex64Format, ProgramHeader->SectionPointer);
	DumpValue(Hex64Format, ProgramHeader->VirtualAddress);
	DumpValue(Hex64Format, ProgramHeader->PhysicalAddress);
	DumpValue(Hex64Format, ProgramHeader->Size);
	DumpValue(Hex64Format, ProgramHeader->SizeInMemory);
	DumpValue(Hex64Format, ProgramHeader->Alignment);
	return(true);
	}

bool
Loader	::	DumpHeader (
	AlphaBinaryExecFile		*ef)
	{
	printf("** Dump ExecFile Header\n");
	printf("-->AlphaBinaryFileHeader\n");
	DumpHeader(&ef->FileHeader);
	printf("-->AlphaBinaryAOutHeader\n");
	DumpHeader(&ef->AOutHeader);

	int	Index =0;
	for(Index=0;Index<ef->FileHeader.NumberOfSections;Index++)
		{
		printf("-->AlphaBinarySectionHeader %d\n", Index);
		DumpHeader(&ef->SectionHeaders[Index]);
		}

	return ( true );
	}

bool
Loader	::DumpHeader (
	LinuxAlphaBinaryExecFile	*ef)
	{
	printf("** Dump ExecFile Header\n");
	printf("-->LinuxAlphaBinaryFileHeader\n");
	DumpHeader(&ef->FileHeader);
	int	Index =0;
	for(Index=0;Index<ef->FileHeader.ProgramHeaderTableCount;Index++)
		{
		printf("-->LinuxAlphaBinaryProgramHeader %d\n", Index);
		DumpHeader(&ef->ProgramHeaders[Index]);
		}

	return(true);
	}

bool
Loader	::	LoadSegmentIntoMemorySystem(
	int							fd,
	AlphaBinaryExecFile			*ef,
	AlphaBinarySectionHeader	*Section,
	AlphaProcessor				*p)
	{

	if(!Section->SectionPointer)
		{
		return(true);
		}

	lseek(fd, Section->SectionPointer, SEEK_SET);

	byte	*Data = new uint8[Section->Size];

	if((uint32)read(fd, Data, Section->Size)!=Section->Size)
		{
		printf("error loading section of file\n");
		delete Data;
		return(false);
		}
	printf("Loading segment to " format_hex_uint64 " - " format_hex_uint64 "\n", (uint64)Section->VirtualAddress, (uint64)Section->VirtualAddress + (uint64)Section->Size);
	if(p->CopyFromHost(
		Section->VirtualAddress,
		(void*)Data,
		Section->Size))
		{
		// gross hack
		uint64	theAddress = Section->VirtualAddress;
		uint64	Count;
		uint64	Size = Section->Size;

		for(Count = 0; Count < Size/4; Count++)
			{
			p->ValidBits->WriteMemory32(theAddress, 1);
			theAddress += 4;
			}
		delete Data;
		return(true);
		}

	printf("Error writing into core\n");
	delete Data;
	return(false);
	}

bool
Loader	::	LoadELFSegmentIntoMemorySystem(
	int								fd,
	LinuxAlphaBinaryExecFile		*ef,
	LinuxAlphaBinaryProgramHeader	*Section,
	AlphaProcessor					*p)
	{
	lseek ( fd, Section->SectionPointer, SEEK_SET);

	byte	*Data = new uint8[Section->Size];

	if((uint32)read(fd, Data, Section->Size)!=Section->Size)
		{
		printf("error loading section of file\n");
		delete Data;
		return(false);
		}
	printf("Loading segment to " format_hex_uint64 " - " format_hex_uint64 "\n", (uint64)Section->VirtualAddress, (uint64)Section->VirtualAddress + (uint64)Section->Size);
	if(p->CopyFromHost(
		Section->VirtualAddress,
		(void*)Data,
		Section->Size))
		{
		// gross hack
		uint64	theAddress = Section->VirtualAddress;
		uint64	Count;
		uint64	Size = Section->Size;

		for(Count = 0; Count < Size/4; Count++)
			{
			p->ValidBits->WriteMemory32(theAddress, 1);
			theAddress += 4;
			}
		delete Data;
		return(true);
		}

	printf("Error writing into core\n");
	delete Data;
	return(false);
	}


#	define	FIS_Update	\
	bOutput = (uint8*)&Output[Size];	\
	uintOutput = (le_uint64*)&Output[Size]

int
Loader	::	FormulateInitialStack (
	uint64				StackBase,
	int					argc,
	char				*argv[],
	char				*argp[],
	unsigned			char	*Output)
	{
	le_uint64		*uintOutput = (le_uint64 *)Output;
	uint8		*bOutput = (byte *)Output;
	int			Size		=	0;

	(*uintOutput) = argc;	Size += sizeof(uint64);	FIS_Update;
	int		ArgvSize = 0;
	int		ArgpSize = 0;
	while(argv[ArgvSize]) ++ArgvSize;
	while(argp[ArgpSize]) ++ArgpSize;

	uint64	FirstString = StackBase + sizeof(uint64) + (ArgvSize+1 + ArgpSize+1)*sizeof(uint64);
	uint64	RunningString = FirstString;

	int		Index = 0;
	while(Index<ArgvSize)
		{
		(*uintOutput) = RunningString;
		Size += sizeof(uint64);
		RunningString += (strlen(argv[Index]) + 1);
		FIS_Update;
		++Index;
		}
	(*uintOutput) = 0;
	Size += sizeof(uint64);
	FIS_Update;
	Index = 0;
	while(Index<ArgpSize)
		{
		(*uintOutput) = RunningString;
		Size += sizeof(uint64);
		RunningString += (strlen(argp[Index]) + 1);
		FIS_Update;
		++Index;
		}
	(*uintOutput) = 0;
	Size += sizeof(uint64);
	FIS_Update;
	// Now, output the strings
	RunningString = FirstString;
	Index = 0;
	int	sIndex;
	while(Index<ArgvSize)
		{
		sIndex = 0;
		while(argv[Index][sIndex])
			{
			(*bOutput) = argv[Index][sIndex];
			++bOutput;
			++Size;
			++RunningString;
			++sIndex;
			}
		(*bOutput) = '\0';
		++bOutput;
		++Size;
		++RunningString;	
		++Index;
		}
	Index = 0;
	while(Index<ArgpSize)
		{
		sIndex = 0;
		while(argp[Index][sIndex])
			{
			(*bOutput) = argp[Index][sIndex];
			++bOutput;
			++Size;
			++RunningString;
			++sIndex;
			}
		(*bOutput) = '\0';
		++bOutput;
		++Size;
		++RunningString;
		++Index;
		}
	return(Size);
	}

bool
Loader	::	LoadELFFromDevice (
	int		fd,
	AlphaProcessor	*p,
	char			**argv,
	char			**argp)
	{
	LinuxAlphaBinaryExecFile		ef;

	int		BytesRead = read(fd, &ef, sizeof(LinuxAlphaBinaryExecFile));

	if(BytesRead != sizeof(LinuxAlphaBinaryExecFile))
		{
		// Error Loading
		return ( false );
		}

//	DumpHeader(&ef);
//	exit(1);

	int	Index;
	for(Index=0;Index<ef.FileHeader.ProgramHeaderTableCount;Index++)
		LoadELFSegmentIntoMemorySystem(fd, &ef, &ef.ProgramHeaders[Index], p);
	(*p->GetProgramCounter()) = ef.FileHeader.InitialPC;
	p->GetIntegerRegisterSet()[sp] = (cuint64(0x11ff0000)<<4); 

	unsigned	char	InitialStack[0x2000];

	// this is a fake argv/argp in case none were surplied.

	char		*t_argv[]	=	{
		"arg0", NULL	};
	char		*t_argp[]	=	{
		"TERM=vt100", "user=noone",NULL	};

	char		**a_argv, **a_argp;

	if(argv==NULL)
		a_argv = t_argv;
	else
		a_argv = argv;
	if(argp == NULL)
		a_argp = t_argp;
	else
		a_argp = argp;

	int			argc = 0;
	while(a_argv[argc])
		++argc;	

	int	InitialStackSize = FormulateInitialStack(
		p->GetIntegerRegisterSet()[sp], argc, a_argv, a_argp, InitialStack);


	p->CopyFromHost(
		(uint64)(p->GetIntegerRegisterSet()[sp]),
		InitialStack,
		InitialStackSize);

	return ( true );
	}

bool
Loader	::	LoadFromDevice (
	int		fd,
	AlphaProcessor	*p,
	char			**argv,
	char			**argp)
	{
	AlphaBinaryExecFile		ef;

	int		BytesRead = read(fd, &ef, sizeof(AlphaBinaryExecFile));

	if(BytesRead != sizeof(AlphaBinaryExecFile))
		{
		// Error Loading
		return ( false );
		}

	if ( (uint16)ef.FileHeader.MagicNumber == 0x457f )
		{
		// this is NOT an ECOFF file.  This is an ELF file.
		lseek(fd, 0, SEEK_SET);
		return(LoadELFFromDevice(fd, p, argv, argp));
		}
//	DumpHeader(&ef);
//	exit(1);

	// Load the segments
	int	Index;
	for(Index=0;Index<ef.FileHeader.NumberOfSections;Index++)
		LoadSegmentIntoMemorySystem(fd, &ef, &ef.SectionHeaders[Index], p);

	(*p->GetProgramCounter()) = ef.AOutHeader.InitialPC;
	p->GetIntegerRegisterSet()[sp] = (cuint64(0x11ff0000)<<4); 
	p->GetIntegerRegisterSet()[gp] = ef.AOutHeader.GPValue;


	unsigned	char	InitialStack[0x2000];

	// this is a fake argv/argp in case none were surplied.

	char		*t_argv[]	=	{
		"arg0", NULL	};
	char		*t_argp[]	=	{
		"TERM=vt100", "user=noone",NULL	};

	char		**a_argv, **a_argp;

	if(argv==NULL)
		a_argv = t_argv;
	else
		a_argv = argv;
	if(argp == NULL)
		a_argp = t_argp;
	else
		a_argp = argp;

	int			argc = 0;
	while(a_argv[argc])
		++argc;	

	int	InitialStackSize = FormulateInitialStack(
		p->GetIntegerRegisterSet()[sp], argc, a_argv, a_argp, InitialStack);


	p->CopyFromHost(
		(uint64)(p->GetIntegerRegisterSet()[sp]),
		InitialStack,
		InitialStackSize);

	return ( true );
	}


bool
Loader	::	LoadFromDevice (
	char			*Filename,
	AlphaProcessor		*p,
	char			**argv,
	char			**argp)
	{
	FILE	*fp = fopen(Filename, "rb");
	if(!fp)
		{
		printf("Error reading input file: %s\n", Filename);
		return ( false );
		}

	bool	Ret = LoadFromDevice(fileno(fp), p, argv, argp);
	fclose(fp);
	if(!Ret)
		{
		printf("Could not load file!\n");
		}
	return ( Ret );
	}

