#	include	"Standard.h"

// Additionally, this file has several system depedent requirements.
extern	"C"
	{
#	include	<fcntl.h>
#	include	<errno.h>
#	include	<sys/stat.h>
#	include	<sys/time.h>
	}

#include "OSFSysCallDefinations.h"

#	define	Negative1	((cuint64(0xffffffff)<<32)|cuint64(0xffffffff))

#	define	Standard_OSF_Epilogue	\
	if (ret != -1)	\
		{		\
		IntegerRegisters[a3] = 0;	\
		IntegerRegisters[v0] = ret;\
		}\
	else\
		{\
		IntegerRegisters[a3] = Negative1;\
		IntegerRegisters[v0] = errno;\
		}

#	define	Error_OSF_Epilogue\
		IntegerRegisters[a3] = Negative1;\
		IntegerRegisters[v0] = 1;


#	define	NoError_OSF_Epilogue\
		IntegerRegisters[a3] = 0;\
		IntegerRegisters[v0] = 0;
		
bool
OSFSystemTrapHandler	::	HandleSystemTrap(
	AlphaProcessor		*FromProcessor,
	AlphaInstruction	*AtInstruction)
	{
	uint64	*IntegerRegisters = FromProcessor->GetIntegerRegisterSet();

//	SystemCallTrace = true;

	if ( SystemCallTrace )
		printf("OSF_syscall := " format_dec_int64 ", (" format_hex_uint64 ", " format_hex_uint64 ", " format_hex_uint64 ", " format_hex_uint64 ")\n",
			IntegerRegisters[v0],
			IntegerRegisters[a0],IntegerRegisters[a1], IntegerRegisters[a2], IntegerRegisters[a3]);

	switch ( IntegerRegisters[v0] )
		{
		case	OSF_SYS_exit:
			return(Perform_OSF_SYS_exit(FromProcessor, IntegerRegisters));
		case	OSF_SYS_fork:
			return(Perform_OSF_SYS_fork(FromProcessor, IntegerRegisters));
		case	OSF_SYS_vfork:
			return(Perform_OSF_SYS_vfork(FromProcessor, IntegerRegisters));
		case	OSF_SYS_read:
			return(Perform_OSF_SYS_read(FromProcessor, IntegerRegisters));
		case	OSF_SYS_write:
			return(Perform_OSF_SYS_write(FromProcessor, IntegerRegisters));
		case	OSF_SYS_open:
			return(Perform_OSF_SYS_open(FromProcessor, IntegerRegisters));
		case	OSF_SYS_close:
			return(Perform_OSF_SYS_close(FromProcessor, IntegerRegisters));
		case	OSF_SYS_old_creat:
			return(Perform_OSF_SYS_creat(FromProcessor, IntegerRegisters));
		case	OSF_SYS_unlink:
			return(Perform_OSF_SYS_unlink(FromProcessor, IntegerRegisters));
		case	OSF_SYS_chdir:
			return(Perform_OSF_SYS_chdir(FromProcessor, IntegerRegisters));
		case	OSF_SYS_chmod:
			return(Perform_OSF_SYS_chmod(FromProcessor, IntegerRegisters));
		case	OSF_SYS_chown:
			return(Perform_OSF_SYS_chown(FromProcessor, IntegerRegisters));
		case	OSF_SYS_sbrk:
			return(Perform_OSF_SYS_brk(FromProcessor, IntegerRegisters));
		case	OSF_SYS_lseek:
			return(Perform_OSF_SYS_lseek(FromProcessor, IntegerRegisters));
		case	OSF_SYS_getuid:
			return(Perform_OSF_SYS_getuid(FromProcessor, IntegerRegisters));
		case	OSF_SYS_access:
			return(Perform_OSF_SYS_access(FromProcessor, IntegerRegisters));
		case	OSF_SYS_stat:
			return(Perform_OSF_SYS_stat(FromProcessor, IntegerRegisters));
		case	OSF_SYS_lstat:
			return(Perform_OSF_SYS_lstat(FromProcessor, IntegerRegisters));
		case	OSF_SYS_dup:
			return(Perform_OSF_SYS_dup(FromProcessor, IntegerRegisters));
		case	OSF_SYS_pipe:
			return(Perform_OSF_SYS_pipe(FromProcessor, IntegerRegisters));
		case	OSF_SYS_getgid:
			return(Perform_OSF_SYS_getgid(FromProcessor, IntegerRegisters));
		case	OSF_SYS_ioctl:
			return(Perform_OSF_SYS_ioctl(FromProcessor, IntegerRegisters));
		case	OSF_SYS_fstat:
			return(Perform_OSF_SYS_fstat(FromProcessor, IntegerRegisters));
		case	OSF_SYS_pagesize:
			return(Perform_OSF_SYS_getpagesize(FromProcessor, IntegerRegisters));
		case	OSF_SYS_fsync:
			return(Perform_OSF_SYS_fsync(FromProcessor, IntegerRegisters));
		case	OSF_SYS_dup2:
			return(Perform_OSF_SYS_dup2(FromProcessor, IntegerRegisters));
		case	OSF_SYS_fcntl:
			return(Perform_OSF_SYS_fcntl(FromProcessor, IntegerRegisters));
		case	OSF_SYS_select:
			return(Perform_OSF_SYS_select(FromProcessor, IntegerRegisters));
//		case	OSF_SYS_gettimeofday:
//			return(Perform_OSF_SYS_gettimeofday(FromProcessor,IntegerRegisters));
		case	OSF_SYS_obreak:
			return(Perform_OSF_SYS_obreak(FromProcessor, IntegerRegisters));
		case	110:
			return(Perform_MP_FetchAndInc(FromProcessor, IntegerRegisters));
		case	111:
			return(Perform_MP_FetchAndDec(FromProcessor, IntegerRegisters));
		case	112:
			return(Perform_MP_GetCPU(FromProcessor, IntegerRegisters));
		case	113:
			return(Perform_MP_GetConfig(FromProcessor, IntegerRegisters));
		case	114:
			return(Perform_MP_Spawn(FromProcessor, IntegerRegisters));
		case	115:
			return(Perform_MP_ICareNow(FromProcessor, IntegerRegisters));
		case	116:
			return(Perform_MP_Pause(FromProcessor, IntegerRegisters));
		case	117:
			return(Perform_MP_Unpause(FromProcessor, IntegerRegisters));
		default:
			return(Perform_Unimplemented(FromProcessor, IntegerRegisters));
		}
	return ( false );
	}
	

bool
OSFSystemTrapHandler	::	TranslateFlagsAlphaToNative(
	uint	*NativeFlags,
	uint64	*AlphaFlags,
	FlagTranslationTableEntry	*TranslationTable)
	{
	if ( ! NativeFlags )
		return ( false );

	(*NativeFlags) = 0;

	if ( ! TranslationTable )
		return ( false );
	if ( ! AlphaFlags )
		return ( false );

	while ( TranslationTable->AlphaFlag )
		{
		if ( (TranslationTable->AlphaFlag & (*AlphaFlags)) == (TranslationTable->AlphaFlag) )
			(*NativeFlags) = (*NativeFlags) | TranslationTable->NativeFlag;
		++TranslationTable;
		}

	return ( true );
	}

bool
OSFSystemTrapHandler	::	TranslateFlagsNativeToAlpha(
	uint64	*AlphaFlags,
	uint	*NativeFlags,
	FlagTranslationTableEntry	*TranslationTable)
	{
	if ( ! AlphaFlags )
		return ( false );

	(*AlphaFlags) = 0;

	if ( ! TranslationTable )
		return ( false );
	if ( ! NativeFlags )
		return ( false );

	while ( TranslationTable->AlphaFlag )	// yes, AlphaFlag
		{
		if ( (TranslationTable->NativeFlag & (*NativeFlags)) == (TranslationTable->NativeFlag) )
			(*AlphaFlags) = (*AlphaFlags) | TranslationTable->AlphaFlag;
		++TranslationTable;
		}

	return ( true );
	}


bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_exit(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	// not sure how to handle exit yet.
	FromProcessor->Halt();
	return ( false );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_fork(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	Error_OSF_Epilogue;
	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_vfork(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	Error_OSF_Epilogue;
	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_read(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	TemporaryBuffer[8192];
	int		Size;

	if(IntegerRegisters[a2] < 0)
		{
		printf("Invalid, asking to read " format_dec_int64 " bytes\n", IntegerRegisters[a2]);
		Error_OSF_Epilogue;
		return ( false );
		}
	Size = (int) IntegerRegisters[a2];
	if ( Size > 8192 )
		Size = 8192;

	int	ret = read((uint)IntegerRegisters[a0], TemporaryBuffer, Size);

	Standard_OSF_Epilogue;

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_read(%d, " format_hex_uint64 ", %d)\n", ret, (uint)IntegerRegisters[a0], IntegerRegisters[a1], (uint)IntegerRegisters[a2]);

	if ( ret > 0 )
		FromProcessor->CopyFromHost(
			IntegerRegisters[a1], (void*)TemporaryBuffer, ret);

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_write(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	TemporaryBuffer[8192];
	int		Size;

	if(IntegerRegisters[a2] < 0)
		{
		printf("Invalid, asking to write " format_dec_int64 " bytes\n", IntegerRegisters[a2]);
		Error_OSF_Epilogue;	
		return ( false );
		}
	Size = (int) IntegerRegisters[a2];
	if ( Size > 8192 )
		Size = 8192;


	FromProcessor->CopyToHost(
		(void*)TemporaryBuffer, IntegerRegisters[a1], Size);

	int	ret = write(IntegerRegisters[a0], TemporaryBuffer, IntegerRegisters[a2]);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_write(%d, " format_hex_uint64 ", %d)\n", ret, (uint)IntegerRegisters[a0], IntegerRegisters[a1], (uint)IntegerRegisters[a2]);

	Standard_OSF_Epilogue;

	return ( true );
	}


static	FlagTranslationTableEntry	OSF_OpenFlags[]	=
	{
		{	00000004,		O_NONBLOCK	},
		{	00000010,		O_APPEND	},
		//{	00000000,		O_RDONLY	},
		{	00000001,		O_WRONLY	},
		{	00000002,		O_RDWR		},
		{	00001000,		O_CREAT		},
		{	00002000,		O_TRUNC		},
		{	00004000,		O_EXCL		},
		{	00010000,		O_NOCTTY	},
		//{	00100000,		O_DRD		},
		LastFlagEntry
	};

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_open(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{

	char	Filename[1024];
	uint64	AlphaFlags = IntegerRegisters[a1];
	uint	NativeFlags;
	uint	Mode = IntegerRegisters[a2];

	TranslateFlagsAlphaToNative(&NativeFlags, &AlphaFlags, OSF_OpenFlags);

	FromProcessor->CopyStringToHost(
		Filename, IntegerRegisters[a0], 1024);

	int	ret;
/*	if(!strcmp(Filename, "/proc/sys/kernel/osrelease"))
		{
		printf("Attempting to open %s -- trapping and preventing\n", Filename);
		ret=-1;
		}
	else*/
		ret = open(Filename, NativeFlags, Mode);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_open(\"%s\", %8.8x, %8.8x)\n", ret, Filename, NativeFlags, Mode);

	Standard_OSF_Epilogue;	

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_close(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	if(IntegerRegisters[a0]<3)	// lie about closing stdin/stdout
		{
		NoError_OSF_Epilogue;

		if ( SystemCallTrace )
			printf("0=OSF_SYS_close(%d) -- lieing about it though (since fd <3)\n", (uint)IntegerRegisters[a0]);

		return ( true );
		}
	int		ret = close((uint)IntegerRegisters[a0]);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_close(%d)\n", ret, (uint)IntegerRegisters[a0]);

	Standard_OSF_Epilogue;	

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_creat(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	Filename[1024];

	FromProcessor->CopyStringToHost(
		Filename, IntegerRegisters[a0], 1024);

	int	ret =  creat(Filename, (uint)IntegerRegisters[a1]);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_creat(%s,%x)\n", ret, Filename,(uint)IntegerRegisters[a1]);

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_unlink(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	Filename[1024];

	FromProcessor->CopyStringToHost(
		Filename, IntegerRegisters[a0], 1024);

	int	ret = unlink(Filename);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_unlink(%s)\n", ret, Filename);

	Standard_OSF_Epilogue

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_chdir(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	Directory[1024];

	FromProcessor->CopyStringToHost(
		Directory, IntegerRegisters[a0], 1024);

	int	ret = chdir(Directory);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_chdir(%s)\n", ret, Directory);

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_chmod(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	Filename[1024];

	FromProcessor->CopyStringToHost(
		Filename, IntegerRegisters[a0], 1024);

	int	ret;
	//ret = chmod(Filename, (uint)IntegerRegisters[a1]);
	ret = 0;

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_chmod(%s, %x) -- lieing about it\n", ret, Filename, (uint)IntegerRegisters[a1]);

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_chown(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	Filename[1024];

	FromProcessor->CopyStringToHost(
		Filename, IntegerRegisters[a0], 1024);

	int		ret;
	//ret = chown(Filename, (uint)IntegerRegisters[a1], (uint)IntegerRegisters[a2]);
	ret = 0;

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_chown(%s, %x, %d) -- lieing about it\n", ret, Filename, (uint)IntegerRegisters[a1], (uint)IntegerRegisters[a2]);

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_brk(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	NoError_OSF_Epilogue;

	return ( false );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_lseek(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	int	ret = lseek((int)IntegerRegisters[a0], (int)IntegerRegisters[a1], (int)IntegerRegisters[a2]);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_lseek(%d, %d, %d)\n", ret, (int)IntegerRegisters[a0], (int)IntegerRegisters[a1],
			(int)IntegerRegisters[a2]);

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_getuid(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	int	ret = getpid();
//	int	ret1 = geteuid();

	Standard_OSF_Epilogue;	

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_access(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	Filename[1024];

	FromProcessor->CopyStringToHost(
		Filename, IntegerRegisters[a0], 1024);

	int	ret = access(Filename, (uint)IntegerRegisters[a1]);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_access(%s, %d)\n", ret, Filename, (uint)IntegerRegisters[a1]);

	Standard_OSF_Epilogue;

	return ( true );
	}

/*
bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_stat(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	NoError_OSF_Epilogue;
	return(true);
	}
bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_lstat(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	NoError_OSF_Epilogue;
	return(true);
	}
bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_fstat(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	NoError_OSF_Epilogue;
	return(true);
	}

*/


typedef	struct	_OSF_stat
	{
	le_uint32		st_dev;		// dev_t
	le_uint32		st_ino;		// ino_t
	le_uint32		st_mode;	// mode_t
	le_uint16		st_nlink;	// nlink_t
	le_uint16		padding1;
	le_uint32		st_uid;		// uid_t
	le_uint32		st_gid;		// gid_t
	le_uint32		st_rdev;	// dev_t
	le_uint32		padding2;
	le_uint64		st_size;	// off_t
	le_uint32		st_aatime;	// time_t
	le_uint32		st_spare1;	// padding?
	le_uint32		st_mmtime;	// time_t
	le_uint32		st_spare2;	// padding?
	le_uint32		st_cctime;	// time_t
	le_uint32		st_spare3;	// padding?
	le_uint32		st_blksize;	// uint_t
	le_uint32		st_blocks;	// int
	le_uint32		st_gen;		// uint_t
	le_uint32		st_flags;	// uint_t
	}	OSF_stat; 

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_stat(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	Filename[1024];
	OSF_stat			OSF_stat_buf;
	struct		stat	stat_buf;

	FromProcessor->CopyStringToHost(
		Filename, IntegerRegisters[a0], 1024);

	int	ret = stat(Filename, &stat_buf);

	Standard_OSF_Epilogue;

	if ( ret < 0 )
		{
		return(true);
		}
	OSF_stat_buf.st_dev = stat_buf.st_dev;
	OSF_stat_buf.st_ino = stat_buf.st_ino;
	OSF_stat_buf.st_mode = stat_buf.st_mode;
	OSF_stat_buf.st_nlink = stat_buf.st_nlink;
	OSF_stat_buf.st_uid = stat_buf.st_uid;
	OSF_stat_buf.st_gid = stat_buf.st_gid;
	OSF_stat_buf.st_rdev = stat_buf.st_rdev;
	OSF_stat_buf.st_size = stat_buf.st_size;
	OSF_stat_buf.st_aatime = stat_buf.st_atime;
	OSF_stat_buf.st_spare1 = 0;
	OSF_stat_buf.st_mmtime = stat_buf.st_mtime;
	OSF_stat_buf.st_spare2 = 0;
	OSF_stat_buf.st_cctime = stat_buf.st_ctime;
	OSF_stat_buf.st_spare3 = 0;
	OSF_stat_buf.st_blksize = stat_buf.st_blksize;
	OSF_stat_buf.st_blocks = stat_buf.st_blocks;
	OSF_stat_buf.st_flags = 0;
	OSF_stat_buf.st_gen = 0;

	FromProcessor->CopyFromHost(
		IntegerRegisters[a1], &OSF_stat_buf, sizeof(OSF_stat));

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_lstat(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	char	Filename[1024];
	OSF_stat			OSF_stat_buf;
	struct		stat	stat_buf;

	FromProcessor->CopyStringToHost(
		Filename, IntegerRegisters[a0], 1024);

	int	ret = lstat(Filename, &stat_buf);

	Standard_OSF_Epilogue;
	if ( ret < 0 )
		{
		return(true);
		}

	OSF_stat_buf.st_dev = stat_buf.st_dev;
	OSF_stat_buf.st_ino = stat_buf.st_ino;
	OSF_stat_buf.st_mode = stat_buf.st_mode;
	OSF_stat_buf.st_nlink = stat_buf.st_nlink;
	OSF_stat_buf.st_uid = stat_buf.st_uid;
	OSF_stat_buf.st_gid = stat_buf.st_gid;
	OSF_stat_buf.st_rdev = stat_buf.st_rdev;
	OSF_stat_buf.st_size = stat_buf.st_size;
	OSF_stat_buf.st_aatime = stat_buf.st_atime;
	OSF_stat_buf.st_spare1 = 0;
	OSF_stat_buf.st_mmtime = stat_buf.st_mtime;
	OSF_stat_buf.st_spare2 = 0;
	OSF_stat_buf.st_cctime = stat_buf.st_ctime;
	OSF_stat_buf.st_spare3 = 0;
	OSF_stat_buf.st_blksize = stat_buf.st_blksize;
	OSF_stat_buf.st_blocks = stat_buf.st_blocks;
	OSF_stat_buf.st_flags = 0;
	OSF_stat_buf.st_gen = 0;

	FromProcessor->CopyFromHost(
		IntegerRegisters[a1], &OSF_stat_buf, sizeof(OSF_stat));

	return ( true );
	}


bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_dup(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	int	ret = dup((int)IntegerRegisters[a0]);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_dup(%d)\n", ret, (int)IntegerRegisters[a0]);

	Standard_OSF_Epilogue;
	
	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_pipe(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	int32		fdw[2];
	int			fd[2];

	FromProcessor->CopyToHost(
		(void*)fdw, IntegerRegisters[a0], 2*sizeof(int32));

	fd[0] = (uint32)fdw[0];
	fd[1] = (uint32)fdw[1];

	int	ret = pipe(fd);

	IntegerRegisters[a3] = fd[0];
	IntegerRegisters[a2] = fd[1];

	fdw[0] = fd[0];
	fdw[1] = fd[1];

	FromProcessor->CopyFromHost(
		IntegerRegisters[a0], (void*)fdw, 2*sizeof(int32));

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_getgid(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	int	ret = getgid();

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_getgid()\n", ret);

	Standard_OSF_Epilogue;
	
	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_ioctl (
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	if ( SystemCallTrace )
		printf("OSF_SYS_ioctl: not supported\n");
	Error_OSF_Epilogue;
	return ( false );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_fstat (
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	OSF_stat			OSF_stat_buf;
	struct		stat	stat_buf;

	int	ret = fstat((int)IntegerRegisters[a0], &stat_buf);

	if ( SystemCallTrace )
		printf("%d=OSF_SYS_fstat(%d, ptr)\n", ret, (int)IntegerRegisters[a0]);

	Standard_OSF_Epilogue;	

	if ( ret < 0 )
		{
		return(true);
		}


	OSF_stat_buf.st_dev = stat_buf.st_dev;
	OSF_stat_buf.st_ino = stat_buf.st_ino;
	OSF_stat_buf.st_mode = stat_buf.st_mode;
	OSF_stat_buf.st_nlink = stat_buf.st_nlink;
	OSF_stat_buf.st_uid = stat_buf.st_uid;
	OSF_stat_buf.st_gid = stat_buf.st_gid;
	OSF_stat_buf.st_rdev = stat_buf.st_rdev;
	OSF_stat_buf.st_size = stat_buf.st_size;
	OSF_stat_buf.st_aatime = stat_buf.st_atime;
	OSF_stat_buf.st_spare1 = 0;
	OSF_stat_buf.st_mmtime = stat_buf.st_mtime;
	OSF_stat_buf.st_spare2 = 0;
	OSF_stat_buf.st_cctime = stat_buf.st_ctime;
	OSF_stat_buf.st_spare3 = 0;
	OSF_stat_buf.st_blksize = stat_buf.st_blksize;
	OSF_stat_buf.st_blocks = stat_buf.st_blocks;
	OSF_stat_buf.st_flags = 0;
	OSF_stat_buf.st_gen = 0;


	if ( IntegerRegisters[a1] )
	FromProcessor->CopyFromHost(
		IntegerRegisters[a1], &OSF_stat_buf, sizeof(OSF_stat));

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_getpagesize (
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	int	ret = 8192;

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_fsync (
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	int	ret = fsync((uint)IntegerRegisters[a0]);

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_dup2 (
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	int	ret = dup2((uint)IntegerRegisters[a0], (uint)IntegerRegisters[a1]);

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_fcntl (
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	int	ret = fcntl((uint)IntegerRegisters[a0], (uint)IntegerRegisters[a1], (uint)IntegerRegisters[a2]);

	Standard_OSF_Epilogue;

	return ( true );
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_select (
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	fd_set	readfd, writefd, exceptfd;
	fd_set	*readfdp, *writefdp, *exceptfdp;
	struct	timeval	timeout, *timeoutp;
//	uint64	zero;

	readfdp = writefdp = exceptfdp = NULL;

	if(IntegerRegisters[a1])
		{
		FromProcessor->CopyToHost((void*)&readfd, IntegerRegisters[a1], sizeof(uint32));
		readfdp = &readfd;
		}
	if(IntegerRegisters[a2])
		{
		FromProcessor->CopyToHost((void*)&writefd, IntegerRegisters[a2], sizeof(uint32));
		writefdp = &writefd;
		}
	if(IntegerRegisters[a3])
		{
		FromProcessor->CopyToHost((void*)&exceptfd, IntegerRegisters[a3], sizeof(uint32));
		exceptfdp = &exceptfd;
		}

	// ignore timeout value, *always* poll.
	timeout.tv_sec = 0;
	timeout.tv_usec = 0;
	timeoutp = &timeout;

	int	ret = select((uint)IntegerRegisters[a0], readfdp, writefdp, exceptfdp, timeoutp);

	if(IntegerRegisters[a1])
		{
		//FromProcessor->CopyFromHost(IntegerRegisters[a1], (void*)&zero, sizeof(uint64));
		FromProcessor->CopyFromHost(IntegerRegisters[a1], (void*)&readfd, sizeof(uint32));
		}
	if(IntegerRegisters[a2])
		{
		//FromProcessor->CopyFromHost(IntegerRegisters[a2], (void*)&zero, sizeof(uint64));
		FromProcessor->CopyFromHost(IntegerRegisters[a2], (void*)&writefd, sizeof(uint32));
		}
	if(IntegerRegisters[a3])
		{
		//FromProcessor->CopyFromHost(IntegerRegisters[a3], (void*)&zero, sizeof(uint64));
		FromProcessor->CopyFromHost(IntegerRegisters[a3], (void*)&exceptfd, sizeof(uint32));
		}

	Standard_OSF_Epilogue;

	return ( true );
	}


bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_gettimeofday(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	// IntegerRegisters[a0] contains a pointer with a timeval struct
	Error_OSF_Epilogue;
	return(true);
	}

bool
OSFSystemTrapHandler	::	Perform_OSF_SYS_obreak(
	AlphaProcessor	*FromProcessor,
	uint64	*IntegerRegisters)
	{
	IntegerRegisters[a3] = 0;
	IntegerRegisters[v0] = IntegerRegisters[a0];
	return(true);
	}


bool
OSFSystemTrapHandler	::	Perform_Unimplemented(
	AlphaProcessor	*FromProcessor,
	uint64			*IntegerRegisters)
	{
	if ( SystemCallTrace )
		printf("Unimplemented sys-call " format_dec_int64 "\n", IntegerRegisters[v0]);
	Error_OSF_Epilogue;
	return(true);
	}

bool
OSFSystemTrapHandler	::	Perform_Implemented(
	AlphaProcessor	*FromProcessor,
	uint64			*IntegerRegisters)
	{
	if ( SystemCallTrace )
		printf("Unimplemented sys-call " format_dec_int64 " -- but lieing about it\n", IntegerRegisters[v0]);
	NoError_OSF_Epilogue;
	return(true);
	}


bool
OSFSystemTrapHandler	::	Perform_MP_FetchAndInc(
	AlphaProcessor	*FromProcessor,
	uint64			*IntegerRegisters)
	{
	uint64	Value, oValue;

	oValue = Value = FromProcessor->theMemory->ReadMemory64(IntegerRegisters[a0]);
	++Value;
	FromProcessor->theMemory->WriteMemory64(IntegerRegisters[a0], Value);
	
	IntegerRegisters[v0] = 0;
	IntegerRegisters[a3] = oValue;
	return(true);
	}

bool
OSFSystemTrapHandler	::	Perform_MP_FetchAndDec(
	AlphaProcessor	*FromProcessor,
	uint64			*IntegerRegisters)
	{
	uint64	Value, oValue;

	oValue = Value = FromProcessor->theMemory->ReadMemory64(IntegerRegisters[a0]);
	--Value;
	FromProcessor->theMemory->WriteMemory64(IntegerRegisters[a0], Value);
	
	IntegerRegisters[v0] = 0;
	IntegerRegisters[a3] = oValue;
	return(true);
	}

bool
OSFSystemTrapHandler	::	Perform_MP_GetCPU(
	AlphaProcessor	*FromProcessor,
	uint64			*IntegerRegisters)
	{
	IntegerRegisters[v0] = 0;
	IntegerRegisters[a3] = FromProcessor->ProcessorNumber;
	return(true);
	}


bool
OSFSystemTrapHandler	::	Perform_MP_GetConfig(
	AlphaProcessor	*FromProcessor,
	uint64		*IntegerRegisters)
	{
	IntegerRegisters[v0] = 0;
	IntegerRegisters[a3] = theSimulator->NumberOfCPUs;
	return(true);
	}

bool
OSFSystemTrapHandler	::	Perform_MP_Spawn(
	AlphaProcessor	*FromProcessor,
	uint64		*IntegerRegisters)
	{

	if ( theSimulator->FastForward )
		{
		printf("Attempting to spawn *while* fast forwarding... this is probably an error, I am attempting to out wit you\n");
		theSimulator->FastForward = false;
		}
	if ( ! IntegerRegisters[a0] )
		{
		FromProcessor->Halt();
		IntegerRegisters[v0] = 0;
		IntegerRegisters[a3] = 0;
		return(true);
		}
	if ( theSimulator->StartThread )
		{
		printf("Attempting to spawn -- but, simulator has not managed previous spawn.  Oh no!\n");
		Error_OSF_Epilogue;
		return(true);
		}
	if ( theSimulator->LiveProcessors >= theSimulator->NumberOfCPUs )
		{
		printf("Attempting to spawn a thead -- but, there is no processor left to run it.  Not good...\n");
		Error_OSF_Epilogue;
		return(true);
		}

	AlphaProcessor	*newAP = new AlphaProcessor;

	newAP->Initialize(FromProcessor, IntegerRegisters[a0], IntegerRegisters[a1], theSimulator->LiveProcessors);	
	theSimulator->StartThread = newAP;

	IntegerRegisters[v0] = 0;
	IntegerRegisters[a3] = theSimulator->LiveProcessors;

	// ok, now, lets just hope that someone who gave a damn picks up this information and runs with it...
	return(true);
	}

bool
OSFSystemTrapHandler	::	Perform_MP_ICareNow(
	AlphaProcessor	*FromProcessor,
	uint64		*IntegerRegisters)
	{
	theSimulator->FastForward = false;
	IntegerRegisters[v0] = 0;
	IntegerRegisters[a3] = 0;
	return(true);
	}

bool
OSFSystemTrapHandler	::	Perform_MP_Pause(
	AlphaProcessor	*FromProcessor,
	uint64		*IntegerRegisters)
	{
	FromProcessor->Pause = true;
	IntegerRegisters[v0] = 0;
	IntegerRegisters[a3] = 0;
	return(true);
	}

bool
OSFSystemTrapHandler	::	Perform_MP_Unpause(
	AlphaProcessor	*FromProcessor,
	uint64		*IntegerRegisters)
	{
	FromProcessor->Pause = alse;
	IntegerRegisters[v0] = 0;
	IntegerRegisters[a3] = 0;
	return(true);
	}
	
