#	include	<stdarg.h>
#	include	<stdio.h>
#	include	<stdlib.h>

#	define	__mp_dont_fix_clib
#	include	"MPLib.h"


int64	ncpus = 1;
int64	cliblock = 1;
volatile	int64	running_threads	=	1;

#undef	malloc
void	*
MPmalloc(
	int	size)
	{
	void	*p;
	down(&cliblock);
	p = (void*)malloc(size);
	up(&cliblock);
	return(p);
	}
	
int
MPprintf(
	char	*s,	
	...)
	{
	va_list	valist;
	int		res;

	down(&cliblock);

	va_start(valist, s);
	res=vprintf(s, valist);fflush(stdout);
	va_end(valist);

	up(&cliblock);
	return(res);
	}

int
MPfprintf(
	FILE	*fp,
	char	*s,
	...)
	{
	va_list	valist;
	int		res;

	down(&cliblock);

	va_start(valist, s);
	res = vfprintf(fp, s, valist);fflush(fp);
	va_end(valist);

	up(&cliblock);
	return(res);
	}

int
MPsprintf(
	char	*s,
	char	*s1,
	...)
	{
	va_list	valist;
	int		res;

	down(&cliblock);

	va_start(valist, s1);
	res = vsprintf(s, s1, valist);
	va_end(valist);

	up(&cliblock);
	return(res);
	}

#undef	fopen
FILE	*
MPfopen(
	char	*file,
	char	*mode)
	{
	FILE	*fp;
	down(&cliblock);
	fp = fopen(file, mode);
	up(&cliblock);
	return(fp);
	}

#undef	fclose
int
MPfclose(
	FILE	*fp)
	{
	int	res;
	down(&cliblock);
	res = fclose(fp);
	up(&cliblock);
	return(res);
	}

#undef	fgets
char	*
MPfgets(
	char	*s,
	int		l,
	FILE	*fp)
	{
	char	*	res;
	down(&cliblock);
	res = fgets(s,l,fp);
	up(&cliblock);
	return(res);
	}

#undef	fputs
int
MPfputs(
	char	*s,
	FILE	*fp)
	{
	int	res;
	down(&cliblock);
	res = fputs(s,fp);
	up(&cliblock);
	return(res);
	}

#undef	fgetc
int
MPfgetc(
	FILE	*fp)
	{
	int	res;
	down(&cliblock);
	res = fgetc(fp);
	up(&cliblock);
	return(res);
	}

#undef	fputc
int
MPfputc(
	int		c,
	FILE	*fp)
	{
	int	res;
	down(&cliblock);
	res = fputc(c, fp);
	up(&cliblock);
	return(res);
	}


int64
up(
	spinlock	*semaphore)
	{
	return(fetchinc(semaphore));
	}

int64
down(
	spinlock	*semaphore)
	{
	int64	x, i, j;
	volatile	spinlock	*s1 = (volatile spinlock *) semaphore;

	while(1)
		{
		MP_DONOTHING(semaphore);
		if ( *semaphore ) {
			x = fetchdec(semaphore);
			if(x>0)
				break;	// got the luck
			fetchinc(semaphore);
		
		i = 0;			// now delay the cpu's in a skewed fashion
		j = (getcpu()*(2));	// so that one that got here "first" gets the
		while(i<j)		// best chance of getting it again.  First is
			++i;		// sort of loosly defined here...
			}
		}
	return(x);
	}

/*


v0 = 0
a0 = 16
a1 = 17
a2 = 18
a3 = 19

*/

int64
fetchinc(
	int64	*counter)
	{
	int64		Result, EResult;
	int64		SysCallNumber = 110;
	__asm__(	"ldq	$16, %2\n"
				"bis $31, 110, $0\n"
				"call_pal 131\n"
				"stq $19, %0\n"
				"stq $0, %1\n" : "=m" (Result), "=m" (EResult) :
					"m" (counter));
	return(Result);
	}

int64
fetchdec(
	int64	*counter)
	{

	int64		Result, EResult;
	int64		SysCallNumber = 111;
	__asm__(	"ldq	$16, %2\n"
				"bis $31, 111, $0\n"
				"call_pal 131\n"
				"stq $19, %0\n"
				"stq $0, %1\n" : "=m" (Result), "=m" (EResult) :
					"m" (counter));
	return(Result);

	}

int64
getcpu()
	{

	int64		Result, EResult;
	int64		SysCallNumber = 112;

	__asm__(	"bis $31, 112, $0\n"
				"call_pal 131\n"
				"stq $19, %0\n"
				"stq $0, %1\n" : "=m" (Result), "=m" (EResult) );
	return(Result);

	}

int64
getncpus()
	{

	int64		Result, EResult;
	int64		SysCallNumber = 113;

	__asm__(	"bis $31, 113, $0\n"
				"call_pal 131\n"
				"stq $19, %0\n"
				"stq $0, %1\n" : "=m" (Result), "=m" (EResult) );

	ncpus = Result;
	
	return(Result);

	}

int64
spawn(int64	pc, int64	stack)
	{
	int64		Result, EResult;
	int64		SysCallNumber = 114;

	if ( pc )	++running_threads;
	else		--running_threads;
	
	getncpus();

	__asm__(	"ldq	$16, %2\n"
				"ldq	$17, %3\n"
				"bis $31, 114, $0\n"
				"call_pal 131\n"
				"stq $19, %0\n"
				"stq $0, %1\n" : "=m" (Result), "=m" (EResult)	:
					"m" (pc), "m" (stack) );
	return(Result);
	}


int64
icarenow()
	{
	int64		Result, EResult;
	int64		SysCallNumber = 115;

	__asm__(	
				"bis $31, 115, $0\n"
				"call_pal 131\n"
				"stq $19, %0\n"
				"stq $0, %1\n" : "=m" (Result), "=m" (EResult)	);
	return(Result);
	}

int64
stopcaring(int64	a)
	{
	exit(a);
	}

	
spinlock	spawn_lock = 1;
typedef	int64	*(func_ptr_type)(void	*);
func_ptr_type		*gfunc;
void				*gptr;


int64
thread_spawn_wrapper()
	{
	func_ptr_type	*lfunc;
	void			*lptr;

	lfunc = gfunc;
	lptr = gptr;

	up(&spawn_lock);
	lfunc(lptr);
	endthread(0);
	// oh no
	
	}

int64
thread_create(void	*func_ptr, void	*data_ptr)
	{
	char	*pc;
	int64	*stack;
	int64	ret;

	down(&spawn_lock);
	gfunc = func_ptr;
	gptr = data_ptr;

	pc = (char*)thread_spawn_wrapper;
	pc += 8;	// hell if I know
	stack = (int64*)MPmalloc(0x1000000);
	stack += 64;	// again, I dunno, seems to work

	ret = (int64)spawn((int64)pc, (int64)stack);

	// not required really
	down(&spawn_lock);
	up(&spawn_lock);
	return(ret);
	}

int64
thread_join_all()
	{
	while ( running_threads > 1 )	;
	return(0);
	}


static	volatile	int64	barrier_count = 0;
static	volatile	int64	barrier_sense	=	0;

int64
thread_barrier()
	{
	int64	local_sense;
	int64	lcpus;

	lcpus = getncpus();
	while ( barrier_count >= lcpus)
		MP_DONOTHING(&barrier_count);

	fetchinc((int64*)&barrier_count);
	local_sense	=	barrier_sense;
	while((barrier_count<lcpus)&&(local_sense == barrier_sense))
		{
		MP_DONOTHING(&barrier_count);
		MP_DONOTHING(&barrier_sense);
		}
	if(getcpu()==0)
		{
		barrier_sense = 1 - barrier_sense;
		barrier_count = 0;
		}

	return(0);
	}



